module DevopsDeploymentLib

  class HttpError < StandardError
    attr_reader :original
    attr_reader :status_code
    
    def initialize(msg, status_code, original=$!)
      super original.nil? ? msg : "#{msg} (original=#{original.message})"
      @status_code = status_code
      @original = original
    end 
  end
  
end