require 'weaver/dsl/abstract_statement'

module Weaver
  module Dsl
    # Represents the attributes on an +attribute+ when expressed in block notation.
    #
    # @see Core::Attribute
    #
    # *Deprecated*
    class AttributeStatement < AbstractStatement

      # *Deprecated*
      def initialize(id, parent_statement)
        @@logger.debug "attribute[id: #{id}]"
        super(id, Attribute, parent_statement)
      end
      
      # *Deprecated*
      def type(attribute_type)
        @model.type = attribute_type
        @model.type.instance_variable_set(:@weaver_origin, weaver_stackframe)
      end
      
      # *Deprecated*
      def label(attribute_label)
        @model.label = attribute_label
        @model.label.instance_variable_set(:@weaver_origin, weaver_stackframe)
      end

      # *Deprecated*
      def required(attribute_required)
        @model.required = attribute_required
        @model.required.instance_variable_set(:@weaver_origin, weaver_stackframe)
      end

      # *Deprecated*
      def default(attribute_default)
        @model.default = attribute_default
        @model.default.instance_variable_set(:@weaver_origin, weaver_stackframe)
      end
      
      # *Deprecated*
      def mutable(attribute_mutable)
        @model.mutable = attribute_mutable
        @model.mutable.instance_variable_set(:@weaver_origin, weaver_stackframe)
      end

      # *Deprecated*
      def group(attribute_group)
        @model.group = attribute_group
        @model.group.instance_variable_set(:@weaver_origin, weaver_stackframe)
      end

      # *Deprecated*
      def to_s
        "attribute[id: #{@id}, name: #{@name}]"
      end

    end

  end

end
