################################################################################
# Licensed Materials - Property of IBM Copyright IBM Corporation 2012. All Rights Reserved.
# U.S. Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP
# Schedule Contract with IBM Corp.
################################################################################

module DevopsLibrary
  class ZipEntry < Zip::ZipEntry
    def get_extra_attributes_from_path(path)
      unless Zip::RUNNING_ON_WINDOWS
        stat = file_stat(path)
        @unix_uid = stat.uid
        #@unix_gid = stat.gid  .. unsupported on JRuby
        @unix_perms = stat.mode & 07777
      end
    end
  end
end
