require 'weaver/core/weaver_error'

module Weaver
  module Validation
    include Weaver::Core # TODO remove this line
    
    # 
    # An exception that is used to indicate validation errors.
    #
    class ValidationError < WeaverError
      # Wrapped original Exception
      attr_reader :original
      
      # a Logger level; Logger::ERROR is usual
      attr_reader :level
      
      # a Base responsible for the message
      attr_reader :context
      
      def initialize(msg, level=nil, context=nil, original=$!)
        super msg
        @original = original
        @level = level
        @context = context
      end
    end
  end
end
